// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: generationmodule/generationmodule.proto

package openfmb.generationmodule;

/**
 * <pre>
 * Generation real power control
 * </pre>
 *
 * Protobuf type {@code generationmodule.RealPowerControl}
 */
public final class RealPowerControl extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:generationmodule.RealPowerControl)
    RealPowerControlOrBuilder {
private static final long serialVersionUID = 0L;
  // Use RealPowerControl.newBuilder() to construct.
  private RealPowerControl(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private RealPowerControl() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new RealPowerControl();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_RealPowerControl_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_RealPowerControl_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.generationmodule.RealPowerControl.class, openfmb.generationmodule.RealPowerControl.Builder.class);
  }

  public static final int DROOPSETPOINT_FIELD_NUMBER = 1;
  private openfmb.generationmodule.DroopParameter droopSetpoint_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.generationmodule.DroopParameter droopSetpoint = 1;</code>
   * @return Whether the droopSetpoint field is set.
   */
  @java.lang.Override
  public boolean hasDroopSetpoint() {
    return droopSetpoint_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.generationmodule.DroopParameter droopSetpoint = 1;</code>
   * @return The droopSetpoint.
   */
  @java.lang.Override
  public openfmb.generationmodule.DroopParameter getDroopSetpoint() {
    return droopSetpoint_ == null ? openfmb.generationmodule.DroopParameter.getDefaultInstance() : droopSetpoint_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.generationmodule.DroopParameter droopSetpoint = 1;</code>
   */
  @java.lang.Override
  public openfmb.generationmodule.DroopParameterOrBuilder getDroopSetpointOrBuilder() {
    return droopSetpoint_ == null ? openfmb.generationmodule.DroopParameter.getDefaultInstance() : droopSetpoint_;
  }

  public static final int ISOCHRONOUSSETPOINT_FIELD_NUMBER = 2;
  private com.google.protobuf.FloatValue isochronousSetpoint_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue isochronousSetpoint = 2;</code>
   * @return Whether the isochronousSetpoint field is set.
   */
  @java.lang.Override
  public boolean hasIsochronousSetpoint() {
    return isochronousSetpoint_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue isochronousSetpoint = 2;</code>
   * @return The isochronousSetpoint.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getIsochronousSetpoint() {
    return isochronousSetpoint_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : isochronousSetpoint_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue isochronousSetpoint = 2;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getIsochronousSetpointOrBuilder() {
    return isochronousSetpoint_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : isochronousSetpoint_;
  }

  public static final int REALPOWERCONTROLMODE_FIELD_NUMBER = 3;
  private openfmb.commonmodule.Optional_RealPowerControlKind realPowerControlMode_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.Optional_RealPowerControlKind realPowerControlMode = 3;</code>
   * @return Whether the realPowerControlMode field is set.
   */
  @java.lang.Override
  public boolean hasRealPowerControlMode() {
    return realPowerControlMode_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.Optional_RealPowerControlKind realPowerControlMode = 3;</code>
   * @return The realPowerControlMode.
   */
  @java.lang.Override
  public openfmb.commonmodule.Optional_RealPowerControlKind getRealPowerControlMode() {
    return realPowerControlMode_ == null ? openfmb.commonmodule.Optional_RealPowerControlKind.getDefaultInstance() : realPowerControlMode_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.Optional_RealPowerControlKind realPowerControlMode = 3;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.Optional_RealPowerControlKindOrBuilder getRealPowerControlModeOrBuilder() {
    return realPowerControlMode_ == null ? openfmb.commonmodule.Optional_RealPowerControlKind.getDefaultInstance() : realPowerControlMode_;
  }

  public static final int REALPOWERSETPOINT_FIELD_NUMBER = 4;
  private com.google.protobuf.FloatValue realPowerSetpoint_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue realPowerSetpoint = 4;</code>
   * @return Whether the realPowerSetpoint field is set.
   */
  @java.lang.Override
  public boolean hasRealPowerSetpoint() {
    return realPowerSetpoint_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue realPowerSetpoint = 4;</code>
   * @return The realPowerSetpoint.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getRealPowerSetpoint() {
    return realPowerSetpoint_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : realPowerSetpoint_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue realPowerSetpoint = 4;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getRealPowerSetpointOrBuilder() {
    return realPowerSetpoint_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : realPowerSetpoint_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (droopSetpoint_ != null) {
      output.writeMessage(1, getDroopSetpoint());
    }
    if (isochronousSetpoint_ != null) {
      output.writeMessage(2, getIsochronousSetpoint());
    }
    if (realPowerControlMode_ != null) {
      output.writeMessage(3, getRealPowerControlMode());
    }
    if (realPowerSetpoint_ != null) {
      output.writeMessage(4, getRealPowerSetpoint());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (droopSetpoint_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getDroopSetpoint());
    }
    if (isochronousSetpoint_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getIsochronousSetpoint());
    }
    if (realPowerControlMode_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getRealPowerControlMode());
    }
    if (realPowerSetpoint_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(4, getRealPowerSetpoint());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.generationmodule.RealPowerControl)) {
      return super.equals(obj);
    }
    openfmb.generationmodule.RealPowerControl other = (openfmb.generationmodule.RealPowerControl) obj;

    if (hasDroopSetpoint() != other.hasDroopSetpoint()) return false;
    if (hasDroopSetpoint()) {
      if (!getDroopSetpoint()
          .equals(other.getDroopSetpoint())) return false;
    }
    if (hasIsochronousSetpoint() != other.hasIsochronousSetpoint()) return false;
    if (hasIsochronousSetpoint()) {
      if (!getIsochronousSetpoint()
          .equals(other.getIsochronousSetpoint())) return false;
    }
    if (hasRealPowerControlMode() != other.hasRealPowerControlMode()) return false;
    if (hasRealPowerControlMode()) {
      if (!getRealPowerControlMode()
          .equals(other.getRealPowerControlMode())) return false;
    }
    if (hasRealPowerSetpoint() != other.hasRealPowerSetpoint()) return false;
    if (hasRealPowerSetpoint()) {
      if (!getRealPowerSetpoint()
          .equals(other.getRealPowerSetpoint())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasDroopSetpoint()) {
      hash = (37 * hash) + DROOPSETPOINT_FIELD_NUMBER;
      hash = (53 * hash) + getDroopSetpoint().hashCode();
    }
    if (hasIsochronousSetpoint()) {
      hash = (37 * hash) + ISOCHRONOUSSETPOINT_FIELD_NUMBER;
      hash = (53 * hash) + getIsochronousSetpoint().hashCode();
    }
    if (hasRealPowerControlMode()) {
      hash = (37 * hash) + REALPOWERCONTROLMODE_FIELD_NUMBER;
      hash = (53 * hash) + getRealPowerControlMode().hashCode();
    }
    if (hasRealPowerSetpoint()) {
      hash = (37 * hash) + REALPOWERSETPOINT_FIELD_NUMBER;
      hash = (53 * hash) + getRealPowerSetpoint().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.generationmodule.RealPowerControl parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.generationmodule.RealPowerControl parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.generationmodule.RealPowerControl parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.generationmodule.RealPowerControl parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.generationmodule.RealPowerControl parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.generationmodule.RealPowerControl parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.generationmodule.RealPowerControl parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.generationmodule.RealPowerControl parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.generationmodule.RealPowerControl parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.generationmodule.RealPowerControl parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.generationmodule.RealPowerControl parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.generationmodule.RealPowerControl parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.generationmodule.RealPowerControl prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Generation real power control
   * </pre>
   *
   * Protobuf type {@code generationmodule.RealPowerControl}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:generationmodule.RealPowerControl)
      openfmb.generationmodule.RealPowerControlOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_RealPowerControl_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_RealPowerControl_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.generationmodule.RealPowerControl.class, openfmb.generationmodule.RealPowerControl.Builder.class);
    }

    // Construct using openfmb.generationmodule.RealPowerControl.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      droopSetpoint_ = null;
      if (droopSetpointBuilder_ != null) {
        droopSetpointBuilder_.dispose();
        droopSetpointBuilder_ = null;
      }
      isochronousSetpoint_ = null;
      if (isochronousSetpointBuilder_ != null) {
        isochronousSetpointBuilder_.dispose();
        isochronousSetpointBuilder_ = null;
      }
      realPowerControlMode_ = null;
      if (realPowerControlModeBuilder_ != null) {
        realPowerControlModeBuilder_.dispose();
        realPowerControlModeBuilder_ = null;
      }
      realPowerSetpoint_ = null;
      if (realPowerSetpointBuilder_ != null) {
        realPowerSetpointBuilder_.dispose();
        realPowerSetpointBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_RealPowerControl_descriptor;
    }

    @java.lang.Override
    public openfmb.generationmodule.RealPowerControl getDefaultInstanceForType() {
      return openfmb.generationmodule.RealPowerControl.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.generationmodule.RealPowerControl build() {
      openfmb.generationmodule.RealPowerControl result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.generationmodule.RealPowerControl buildPartial() {
      openfmb.generationmodule.RealPowerControl result = new openfmb.generationmodule.RealPowerControl(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.generationmodule.RealPowerControl result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.droopSetpoint_ = droopSetpointBuilder_ == null
            ? droopSetpoint_
            : droopSetpointBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.isochronousSetpoint_ = isochronousSetpointBuilder_ == null
            ? isochronousSetpoint_
            : isochronousSetpointBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.realPowerControlMode_ = realPowerControlModeBuilder_ == null
            ? realPowerControlMode_
            : realPowerControlModeBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000008) != 0)) {
        result.realPowerSetpoint_ = realPowerSetpointBuilder_ == null
            ? realPowerSetpoint_
            : realPowerSetpointBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.generationmodule.RealPowerControl) {
        return mergeFrom((openfmb.generationmodule.RealPowerControl)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.generationmodule.RealPowerControl other) {
      if (other == openfmb.generationmodule.RealPowerControl.getDefaultInstance()) return this;
      if (other.hasDroopSetpoint()) {
        mergeDroopSetpoint(other.getDroopSetpoint());
      }
      if (other.hasIsochronousSetpoint()) {
        mergeIsochronousSetpoint(other.getIsochronousSetpoint());
      }
      if (other.hasRealPowerControlMode()) {
        mergeRealPowerControlMode(other.getRealPowerControlMode());
      }
      if (other.hasRealPowerSetpoint()) {
        mergeRealPowerSetpoint(other.getRealPowerSetpoint());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getDroopSetpointFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getIsochronousSetpointFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getRealPowerControlModeFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            case 34: {
              input.readMessage(
                  getRealPowerSetpointFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000008;
              break;
            } // case 34
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.generationmodule.DroopParameter droopSetpoint_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.generationmodule.DroopParameter, openfmb.generationmodule.DroopParameter.Builder, openfmb.generationmodule.DroopParameterOrBuilder> droopSetpointBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.DroopParameter droopSetpoint = 1;</code>
     * @return Whether the droopSetpoint field is set.
     */
    public boolean hasDroopSetpoint() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.DroopParameter droopSetpoint = 1;</code>
     * @return The droopSetpoint.
     */
    public openfmb.generationmodule.DroopParameter getDroopSetpoint() {
      if (droopSetpointBuilder_ == null) {
        return droopSetpoint_ == null ? openfmb.generationmodule.DroopParameter.getDefaultInstance() : droopSetpoint_;
      } else {
        return droopSetpointBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.DroopParameter droopSetpoint = 1;</code>
     */
    public Builder setDroopSetpoint(openfmb.generationmodule.DroopParameter value) {
      if (droopSetpointBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        droopSetpoint_ = value;
      } else {
        droopSetpointBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.DroopParameter droopSetpoint = 1;</code>
     */
    public Builder setDroopSetpoint(
        openfmb.generationmodule.DroopParameter.Builder builderForValue) {
      if (droopSetpointBuilder_ == null) {
        droopSetpoint_ = builderForValue.build();
      } else {
        droopSetpointBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.DroopParameter droopSetpoint = 1;</code>
     */
    public Builder mergeDroopSetpoint(openfmb.generationmodule.DroopParameter value) {
      if (droopSetpointBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          droopSetpoint_ != null &&
          droopSetpoint_ != openfmb.generationmodule.DroopParameter.getDefaultInstance()) {
          getDroopSetpointBuilder().mergeFrom(value);
        } else {
          droopSetpoint_ = value;
        }
      } else {
        droopSetpointBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.DroopParameter droopSetpoint = 1;</code>
     */
    public Builder clearDroopSetpoint() {
      bitField0_ = (bitField0_ & ~0x00000001);
      droopSetpoint_ = null;
      if (droopSetpointBuilder_ != null) {
        droopSetpointBuilder_.dispose();
        droopSetpointBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.DroopParameter droopSetpoint = 1;</code>
     */
    public openfmb.generationmodule.DroopParameter.Builder getDroopSetpointBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getDroopSetpointFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.DroopParameter droopSetpoint = 1;</code>
     */
    public openfmb.generationmodule.DroopParameterOrBuilder getDroopSetpointOrBuilder() {
      if (droopSetpointBuilder_ != null) {
        return droopSetpointBuilder_.getMessageOrBuilder();
      } else {
        return droopSetpoint_ == null ?
            openfmb.generationmodule.DroopParameter.getDefaultInstance() : droopSetpoint_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.DroopParameter droopSetpoint = 1;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.generationmodule.DroopParameter, openfmb.generationmodule.DroopParameter.Builder, openfmb.generationmodule.DroopParameterOrBuilder> 
        getDroopSetpointFieldBuilder() {
      if (droopSetpointBuilder_ == null) {
        droopSetpointBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.generationmodule.DroopParameter, openfmb.generationmodule.DroopParameter.Builder, openfmb.generationmodule.DroopParameterOrBuilder>(
                getDroopSetpoint(),
                getParentForChildren(),
                isClean());
        droopSetpoint_ = null;
      }
      return droopSetpointBuilder_;
    }

    private com.google.protobuf.FloatValue isochronousSetpoint_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> isochronousSetpointBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue isochronousSetpoint = 2;</code>
     * @return Whether the isochronousSetpoint field is set.
     */
    public boolean hasIsochronousSetpoint() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue isochronousSetpoint = 2;</code>
     * @return The isochronousSetpoint.
     */
    public com.google.protobuf.FloatValue getIsochronousSetpoint() {
      if (isochronousSetpointBuilder_ == null) {
        return isochronousSetpoint_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : isochronousSetpoint_;
      } else {
        return isochronousSetpointBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue isochronousSetpoint = 2;</code>
     */
    public Builder setIsochronousSetpoint(com.google.protobuf.FloatValue value) {
      if (isochronousSetpointBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        isochronousSetpoint_ = value;
      } else {
        isochronousSetpointBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue isochronousSetpoint = 2;</code>
     */
    public Builder setIsochronousSetpoint(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (isochronousSetpointBuilder_ == null) {
        isochronousSetpoint_ = builderForValue.build();
      } else {
        isochronousSetpointBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue isochronousSetpoint = 2;</code>
     */
    public Builder mergeIsochronousSetpoint(com.google.protobuf.FloatValue value) {
      if (isochronousSetpointBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          isochronousSetpoint_ != null &&
          isochronousSetpoint_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getIsochronousSetpointBuilder().mergeFrom(value);
        } else {
          isochronousSetpoint_ = value;
        }
      } else {
        isochronousSetpointBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue isochronousSetpoint = 2;</code>
     */
    public Builder clearIsochronousSetpoint() {
      bitField0_ = (bitField0_ & ~0x00000002);
      isochronousSetpoint_ = null;
      if (isochronousSetpointBuilder_ != null) {
        isochronousSetpointBuilder_.dispose();
        isochronousSetpointBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue isochronousSetpoint = 2;</code>
     */
    public com.google.protobuf.FloatValue.Builder getIsochronousSetpointBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getIsochronousSetpointFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue isochronousSetpoint = 2;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getIsochronousSetpointOrBuilder() {
      if (isochronousSetpointBuilder_ != null) {
        return isochronousSetpointBuilder_.getMessageOrBuilder();
      } else {
        return isochronousSetpoint_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : isochronousSetpoint_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue isochronousSetpoint = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getIsochronousSetpointFieldBuilder() {
      if (isochronousSetpointBuilder_ == null) {
        isochronousSetpointBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getIsochronousSetpoint(),
                getParentForChildren(),
                isClean());
        isochronousSetpoint_ = null;
      }
      return isochronousSetpointBuilder_;
    }

    private openfmb.commonmodule.Optional_RealPowerControlKind realPowerControlMode_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Optional_RealPowerControlKind, openfmb.commonmodule.Optional_RealPowerControlKind.Builder, openfmb.commonmodule.Optional_RealPowerControlKindOrBuilder> realPowerControlModeBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_RealPowerControlKind realPowerControlMode = 3;</code>
     * @return Whether the realPowerControlMode field is set.
     */
    public boolean hasRealPowerControlMode() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_RealPowerControlKind realPowerControlMode = 3;</code>
     * @return The realPowerControlMode.
     */
    public openfmb.commonmodule.Optional_RealPowerControlKind getRealPowerControlMode() {
      if (realPowerControlModeBuilder_ == null) {
        return realPowerControlMode_ == null ? openfmb.commonmodule.Optional_RealPowerControlKind.getDefaultInstance() : realPowerControlMode_;
      } else {
        return realPowerControlModeBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_RealPowerControlKind realPowerControlMode = 3;</code>
     */
    public Builder setRealPowerControlMode(openfmb.commonmodule.Optional_RealPowerControlKind value) {
      if (realPowerControlModeBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        realPowerControlMode_ = value;
      } else {
        realPowerControlModeBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_RealPowerControlKind realPowerControlMode = 3;</code>
     */
    public Builder setRealPowerControlMode(
        openfmb.commonmodule.Optional_RealPowerControlKind.Builder builderForValue) {
      if (realPowerControlModeBuilder_ == null) {
        realPowerControlMode_ = builderForValue.build();
      } else {
        realPowerControlModeBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_RealPowerControlKind realPowerControlMode = 3;</code>
     */
    public Builder mergeRealPowerControlMode(openfmb.commonmodule.Optional_RealPowerControlKind value) {
      if (realPowerControlModeBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          realPowerControlMode_ != null &&
          realPowerControlMode_ != openfmb.commonmodule.Optional_RealPowerControlKind.getDefaultInstance()) {
          getRealPowerControlModeBuilder().mergeFrom(value);
        } else {
          realPowerControlMode_ = value;
        }
      } else {
        realPowerControlModeBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_RealPowerControlKind realPowerControlMode = 3;</code>
     */
    public Builder clearRealPowerControlMode() {
      bitField0_ = (bitField0_ & ~0x00000004);
      realPowerControlMode_ = null;
      if (realPowerControlModeBuilder_ != null) {
        realPowerControlModeBuilder_.dispose();
        realPowerControlModeBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_RealPowerControlKind realPowerControlMode = 3;</code>
     */
    public openfmb.commonmodule.Optional_RealPowerControlKind.Builder getRealPowerControlModeBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getRealPowerControlModeFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_RealPowerControlKind realPowerControlMode = 3;</code>
     */
    public openfmb.commonmodule.Optional_RealPowerControlKindOrBuilder getRealPowerControlModeOrBuilder() {
      if (realPowerControlModeBuilder_ != null) {
        return realPowerControlModeBuilder_.getMessageOrBuilder();
      } else {
        return realPowerControlMode_ == null ?
            openfmb.commonmodule.Optional_RealPowerControlKind.getDefaultInstance() : realPowerControlMode_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_RealPowerControlKind realPowerControlMode = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Optional_RealPowerControlKind, openfmb.commonmodule.Optional_RealPowerControlKind.Builder, openfmb.commonmodule.Optional_RealPowerControlKindOrBuilder> 
        getRealPowerControlModeFieldBuilder() {
      if (realPowerControlModeBuilder_ == null) {
        realPowerControlModeBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.Optional_RealPowerControlKind, openfmb.commonmodule.Optional_RealPowerControlKind.Builder, openfmb.commonmodule.Optional_RealPowerControlKindOrBuilder>(
                getRealPowerControlMode(),
                getParentForChildren(),
                isClean());
        realPowerControlMode_ = null;
      }
      return realPowerControlModeBuilder_;
    }

    private com.google.protobuf.FloatValue realPowerSetpoint_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> realPowerSetpointBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue realPowerSetpoint = 4;</code>
     * @return Whether the realPowerSetpoint field is set.
     */
    public boolean hasRealPowerSetpoint() {
      return ((bitField0_ & 0x00000008) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue realPowerSetpoint = 4;</code>
     * @return The realPowerSetpoint.
     */
    public com.google.protobuf.FloatValue getRealPowerSetpoint() {
      if (realPowerSetpointBuilder_ == null) {
        return realPowerSetpoint_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : realPowerSetpoint_;
      } else {
        return realPowerSetpointBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue realPowerSetpoint = 4;</code>
     */
    public Builder setRealPowerSetpoint(com.google.protobuf.FloatValue value) {
      if (realPowerSetpointBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        realPowerSetpoint_ = value;
      } else {
        realPowerSetpointBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue realPowerSetpoint = 4;</code>
     */
    public Builder setRealPowerSetpoint(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (realPowerSetpointBuilder_ == null) {
        realPowerSetpoint_ = builderForValue.build();
      } else {
        realPowerSetpointBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue realPowerSetpoint = 4;</code>
     */
    public Builder mergeRealPowerSetpoint(com.google.protobuf.FloatValue value) {
      if (realPowerSetpointBuilder_ == null) {
        if (((bitField0_ & 0x00000008) != 0) &&
          realPowerSetpoint_ != null &&
          realPowerSetpoint_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getRealPowerSetpointBuilder().mergeFrom(value);
        } else {
          realPowerSetpoint_ = value;
        }
      } else {
        realPowerSetpointBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue realPowerSetpoint = 4;</code>
     */
    public Builder clearRealPowerSetpoint() {
      bitField0_ = (bitField0_ & ~0x00000008);
      realPowerSetpoint_ = null;
      if (realPowerSetpointBuilder_ != null) {
        realPowerSetpointBuilder_.dispose();
        realPowerSetpointBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue realPowerSetpoint = 4;</code>
     */
    public com.google.protobuf.FloatValue.Builder getRealPowerSetpointBuilder() {
      bitField0_ |= 0x00000008;
      onChanged();
      return getRealPowerSetpointFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue realPowerSetpoint = 4;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getRealPowerSetpointOrBuilder() {
      if (realPowerSetpointBuilder_ != null) {
        return realPowerSetpointBuilder_.getMessageOrBuilder();
      } else {
        return realPowerSetpoint_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : realPowerSetpoint_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue realPowerSetpoint = 4;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getRealPowerSetpointFieldBuilder() {
      if (realPowerSetpointBuilder_ == null) {
        realPowerSetpointBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getRealPowerSetpoint(),
                getParentForChildren(),
                isClean());
        realPowerSetpoint_ = null;
      }
      return realPowerSetpointBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:generationmodule.RealPowerControl)
  }

  // @@protoc_insertion_point(class_scope:generationmodule.RealPowerControl)
  private static final openfmb.generationmodule.RealPowerControl DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.generationmodule.RealPowerControl();
  }

  public static openfmb.generationmodule.RealPowerControl getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<RealPowerControl>
      PARSER = new com.google.protobuf.AbstractParser<RealPowerControl>() {
    @java.lang.Override
    public RealPowerControl parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<RealPowerControl> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<RealPowerControl> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.generationmodule.RealPowerControl getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

